EBROWSE: parse c++11 rstrings

C++11 allows definition of  multi-line stirngs. This patch makes ebrowse propely parse these strings.

Example of test multi-line string:

repro.cxx:
----------
struct Foo {
    using STR = const char*;
    STR rstrprefix = R"prefix(is is a C++11 multi
    line string
)prefix";

    STR rstr = R"(
multiline string without a prefix
)";

    STR rstr_test = R"prefix(
)prefix not at end
)prefixtoolong"
)pref" to short

string still continues
)prefix";

    const char* str = "a regular string";

    void func() {
    }
};
----------

~/project/test/lit_repro $ c++ -std=c++10 -c repro.cxx     # repro.cxx compiles

~/project/test/lit_repro $ ebrowse repro.cxx               # current ebrowse chokes on file and produces wrong symbols
repro.cxx:3: newline in string constant
repro.cxx:4: newline in string constant
repro.cxx:7: newline in string constant
repro.cxx:8: newline in string constant
repro.cxx:11: newline in string constant
repro.cxx:12: newline in string constant
repro.cxx:14: newline in string constant
repro.cxx:15: newline in string constant
repro.cxx:16: newline in string constant
~/project/test/lit_repro $ cat BROWSE
[ebrowse-hs "ebrowse 5.0" " -x" () ()][ebrowse-ts [ebrowse-cs "Foo" () 0"repro.cxx" "struct Foo {" 12"repro.cxx" ]
()([ebrowse-ms "R" () 0 () "multiline string without a prefix
)\";" 175 0  () () 0]
[ebrowse-ms "pref" () 0 () ")prefix\";" 291 0  () () 0]
[ebrowse-ms "str" () 0 () "    const char* str = \"a regular string\";" 334 0  () () 0]
)
([ebrowse-ms "func" () 0 () "    void func()" 351 0  () "    void func()" 351]
)
~/project/test/lit_repro $  ~/Downloads/emacs-master/lib-src/ebrowse repro.cxx    # patch properly parses source and generates symbols
~/project/test/lit_repro $ cat BROWSE
[ebrowse-hs "ebrowse 5.0" " -x" () ()][ebrowse-ts [ebrowse-cs "Foo" () 0"repro.cxx" "struct Foo {" 12"repro.cxx" ]
()([ebrowse-ms "rstr" () 0 () "multiline string without a prefix
)\";" 175 0  () () 0]
[ebrowse-ms "rstr_test" () 0 () ")prefix\";" 291 0  () () 0]
[ebrowse-ms "rstrprefix" () 0 () ")prefix\";" 117 0  () () 0]
[ebrowse-ms "str" () 0 () "    const char* str = \"a regular string\";" 334 0  () () 0]
)
([ebrowse-ms "func" () 0 () "    void func()" 351 0  () "    void func()" 351]
)
Index: emacs-master/lib-src/ebrowse.c
===================================================================
--- emacs-master.orig/lib-src/ebrowse.c
+++ emacs-master/lib-src/ebrowse.c
@@ -1574,6 +1574,51 @@ yylex (void)
 
         end_string:
           return end_char == '\'' ? CCHAR : CSTRING;
+	case 'R':
+	  if (GET (c) == '"') {
+	    /* c++11 rstrings */
+
+            #define RSTRING_EOF_CHECK do {if (c=='\0') { yyerror("unterminated c++11 rstring", NULL); UNGET(); return CSTRING;}}while(0)
+	    char *rstring_prefix_start = in;
+
+	    while (GET (c) != '(') {
+	      RSTRING_EOF_CHECK;
+	      if (c == '"')
+		{
+		  yyerror ("malformed c++11 rstring", NULL);
+		  return CSTRING;
+		}
+	    }
+	    char *rstring_prefix_end = in - 1;
+	    while (TRUE) {
+	      switch(GET (c)) {
+	      default:
+		RSTRING_EOF_CHECK;
+		break;
+	      case '\n':
+		INCREMENT_LINENO;
+		break;
+	      case ')':
+		{
+		  char *in_saved = in;
+		  char *prefix = rstring_prefix_start;
+		  while (prefix != rstring_prefix_end && GET (c) == *prefix) {
+		    RSTRING_EOF_CHECK;
+		    prefix++;
+		  }
+		  if (prefix == rstring_prefix_end) {
+		    if (GET(c) == '"')
+		      return CSTRING;
+		    RSTRING_EOF_CHECK;
+		  }
+		  in = in_saved;
+		}
+	      }
+	    }
+	  }
+
+          UNGET ();
+          /* fall through to ident */
 
         case 'a': case 'b': case 'c': case 'd': case 'e': case 'f': case 'g':
         case 'h': case 'i': case 'j': case 'k': case 'l': case 'm': case 'n':
@@ -1581,7 +1626,7 @@ yylex (void)
         case 'v': case 'w': case 'x': case 'y': case 'z':
         case 'A': case 'B': case 'C': case 'D': case 'E': case 'F': case 'G':
         case 'H': case 'I': case 'J': case 'K': case 'L': case 'M': case 'N':
-        case 'O': case 'P': case 'Q': case 'R': case 'S': case 'T': case 'U':
+        case 'O': case 'P': case 'Q': case 'S': case 'T': case 'U':
         case 'V': case 'W': case 'X': case 'Y': case 'Z': case '_':
           {
             /* Identifier and keywords.  */
